require_relative 'field'
class Stone #Stone class contains letter, value, possition and other variables needed
  attr_accessor :letter, :score, :posX, :posY, :static, :followCursor, :myField, :checked, :imageDown
  def initialize (pos_x,pos_y, img, stn, scr, ltr, gme, imgDown)
    #stone position
    @posX = pos_x
    @posY = pos_y
    @image = img #stone image
    @score = scr #stone score
    @letter = ltr #letter
    @actualImage = img #actual image to show
    @game = gme #gosu game window
    @imageDown = imgDown #hover image
    @buttonWidth = @image.width.to_f #stone image width
    @buttonHeight = @image.height.to_f #stone image height
    @static = false #can stone be moved
    @followCursor = false #is stone attached to cursor
    @myField = nil #fild stone is on
    @checked = false #is stone properly connected to starting field/stone
  end

  def draw #draw stone
    @actualImage.draw(@posX, @posY, 2)
  end

  def isHovering #is cursor hovering over this stone
    x = @game.mouse_x
    y = @game.mouse_y
    if x >= @posX && x <= (@posX + @buttonWidth) && y >= @posY && y <= @posY + @buttonHeight
      true
    else
      false
    end
  end

  def update
    if @followCursor #if is attached to cursor, then set it's possition to it
      @posX = @game.mouse_x
      @posY = @game.mouse_y
    end
    if isHovering #set image based on if is cursor hovering over it
      @actualImage = @imageDown
    else
      @actualImage = @image
    end
  end

  def clicked #evaluate click
    isOver = isHovering
    if @followCursor #&& isOver #if is attached to cursor then detach it and try to place it on board
      @followCursor = false
      @game.board.placeStone(self)
      return
    elsif !(@followCursor) && !(@static) && isOver #if is not static and not following and cursor is over it, then attach it to cursor and detach it from field
      @followCursor = true
      @game.board.markAvailableFields
      if @myField != nil
        @myField.stone = nil
        @myField = nil
      end
      true
    end
  end

end